;----------------------------------------------------------------------------
;Touch is a Modification of DVRFUNC.ASM from ELO to make it a Callable
;routine from Basic or C. It passes the Column,Line of TouchScreen Untouch.
;If called with Waitstate > 0 then it waits for an Untouch
;			  = 0 then it returns 0,0 if still Touching.
;Call first with Line = 1 which opens device. Thereafter calls are made
;normally with Line	  = 0 and Column = 0 but Waitstate may be > 0.
;
;It appears that if Untouch event occurrs during our abscence the event
;is remembered and retrieves correctly.
;
;Basic Declare = Declare Sub Touch(Linenr&,Column&,Waitstate&)
;----------------------------------------------------------------------------
	.MODEL MEDIUM
	.486
	.DATA
	;-------------------------------------------------------------------
	EloInt			db	65h				; int where ELODEV found
	OurXlateRange	dw	1,80,1,25,1,15	; for setting XlateRange
	TouchFlag		dw	?
	;-------------------------------------------------------------------
	.CODE
	PUBLIC	TOUCH
	;--------------------------
	WaitAddr	DW	?
	WaitState	DW	?
	ColumnAddr	DW	?
	Column		DW	?
	LineAddr	DW	?
	Line		DW	?
;-----------------------------------------------------------------------------
TOUCH	PROC	FAR
	;---------
	PUSH    BP
	MOV     BP,SP
	;---------
	PUSH	DX
	PUSH    CX
	PUSH    BX
	PUSH    AX
	;-------------------------------
	MOV		BX,[BP+6]		 ;get WaitState from stack.
	MOV		WaitAddr,BX
	MOV		AX,[BX]
	MOV		WaitState,AX	 ;wait for untouch or not.

	MOV		BX,[BP+8]		 ;get column from stack.
	MOV		ColumnAddr,BX	 ;This can be used to pass info
	MOV		AX,[BX] 		 ;to this routine, but is used to
	MOV		Column,AX		 ;pass Column Nr back to Caller.

	MOV		BX,[BP+10]		 ;get Linenr from stack.
	MOV		LineAddr,BX
	MOV		AX,[BX]
	MOV		Line,AX
	;------------------------------
	mov		TouchFlag,0		; clear it from last call.
	cmp		line,0			; Do we need to Open Device ?
	je		TLoop			; If not, skip over next statements.
	;----------------
	mov		ax,1			; OpenTouch
	call	intr
	mov		ax,5			; SetMode to Stream, Xlated, Untouch
	mov		bx,02h	    	;08h OR 02h		; XLATED OR UNTOUCH
	call	intr
	mov		ax,15			; SetXlateRange
	mov		bx,offset OurXlateRange
	call	intr
	mov		ax,3			; EnableTouch interrupts
	call	intr
	;----------------
TLoop:
	mov		ah,1			; abort on keypress
	int		16h
	jne		Dos_Exit

	mov		ax,8			; GetTouch
	call	intr
	or		ax,ax			; any data?
	je		done			; no
	
	MOV		Column,BX		; yes - get X coord
	MOV		Line,CX 		; Y coord
	or		dx,dx			; untouch flag
	jne		showut
	mov		TouchFlag,1		; No still touching
	MOV		Column,0		; so dont save X Y detail.
	MOV		Line,0
	jmp		TLoop
showut:
	mov		TouchFlag,-1
Done:
	cmp		WaitState,0		; are we supposed to wait for a touch?
	je		@f				; no so skip next test
	cmp		TouchFlag,-1	; yes so did touch finish ?
	jne		TLoop			; no so get next data.
@@:							; yes so finish off.
	;mov	ax,2			; CloseTouch
	;call	intr
	jmp	Dos_Exit
;----------------------------------------------------------------------------
; Call ELODEV at interrupt EloInt. This is self modifying code.
; Too bad there isn't a "INT AX" or "INT EloInt" instruction.
;----------------------------------------------------------------------------
intr	proc	near
	push	ax				;val = 8
	mov		al,EloInt		;    = 65
	mov		byte ptr cs: i1+1,al
	pop		ax
	jmp		i1				; purge the prefetch queue
i1:	int		60				; modified instruction
	ret
intr		ENDP
;----------------------------------------------------------------------------
;
;----------------------------------------------------------------------------
Dos_Exit:
	MOV		BX,ColumnAddr
	MOV		AX,Column
	MOV		[BX],AX

	MOV		BX,LineAddr
	MOV		AX,Line
	MOV		[BX],AX

	MOV		BX,WaitAddr
	MOV		AX,WaitState
	MOV		[BX],AX
	;*********
	POP     AX
	POP     BX
	POP     CX
	POP     DX
	;*********
	POP     BP
	RET		6
TOUCH		ENDP
	END
